unit Funcs;

interface
uses Kol;

  function BuildStr(s: string; c: char; n: LongInt): string;
  function FrameType(Index: Integer): Integer;
  procedure BMPInit;
  procedure GenerateImage(FType: byte; FIn: PStream; FOut: PStream; SOffset: LongInt; Bitmap: PBitmap);

const
  ftNone=0;
  ftFull=1;
  ftItem=2;

var
  Options: record
             Zoom: LongInt;
           end;
  TempBitmap: PBitmap;
  FWl6: PStream;
  CurDir: string;
  TotalFiles: Word;
  Wl6Name: string;
  id: array[1..2]of char;
  BMPHeader: RECORD
               FullSize: LongInt;
               _H1: LongInt;
               _C1: LongInt;
               _C2: LongInt;
               X: LongInt;
               Y: LongInt;
               _C3: Word;
               _C4: Word;
               _H2: LongInt;
               _H3: LongInt;
               DataSize1: LongInt;     //DataSize=X*Y+2*Y
               DataSize2: LongInt;     //DataSize=X*Y+2*Y
               _C5: ARRAY[1..8]OF Byte;
             END;
  Palette: array[0..255]of record
                             R,G,B,F: Byte;
                           end;
  Entries: array of record
                      Offset: LongInt;
                      Size: Word;
                    end;
implementation

function FrameType(Index: Integer): Integer;
begin
  if Index>540 then FrameType:=ftNone else
  if Index>105 then FrameType:=ftItem else FrameType:=ftFull;
end;

procedure BMPInit;
var
  i: Integer;
  FPal: PStream;
begin
  id[1]:='B';
  id[2]:='M';
  TempBitmap:=NewBitmap(64,64);
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
  GetDir(0,CurDir);
  Options.Zoom:=1;
  {***  }
  FPal:=NewReadFileStream('palette.pal');
  for i:=0 to 255 do
  begin
    FPal.Read(Palette[i].B,1);
    FPal.Read(Palette[i].G,1);
    FPal.Read(Palette[i].R,1);
    Palette[i].r:=Palette[i].r shl 2;
    Palette[i].g:=Palette[i].g shl 2;
    Palette[i].b:=Palette[i].b shl 2;
    Palette[i].F:=$00;
  end;
  FPal.Free;
end;

function BuildStr(s: string; c: char; n: LongInt): string;
var
  t: string;
begin
  if Length(s)=n then
  begin
    BuildStr:=s;
    Exit;
  end;
  t:=s;
  While Length(t)<n do t:=c+t;
  BuildStr:=t;
end;

procedure GenerateImage(FType: byte; FIn: PStream; FOut: PStream; SOffset: LongInt; Bitmap: PBitmap);
var
  TWidth,THeight,RealWidth,x,y: Integer;
  BuffIn,BuffOut: array[0..63,0..63]of byte;
  SmallBuff: array[0..63]of byte;
// 
  Word1,Word2,OffsetLow,OffsetHigh,Hlam,TZero,SCount: Word;
  DataOffset,i,j,SegmentLength,SavePos: LongInt;
  CEntries: array [0..63] of Word;
  SEntries: array of array of record
                                Low: Word;
                                Offset: Word;
                                High: Word;
                              end;
  z: LongInt;
begin
  TWidth:=64;
  THeight:=64;
  BMPHeader.x:=TWidth;
  BMPHeader.y:=THeight;
  BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
  BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
  BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
  BMPHeader._H3:=BMPHeader.FullSize-$36;
  FOut.Seek(0,spBegin);
  FOut.Write(id,SizeOf(id));
  FOut.Write(BMPHeader,SizeOf(BMPHeader));
  FOut.Write(Palette,SizeOf(Palette));
  case FType of
  ftFull:begin
           FIn.Seek(SOffset,spBegin);
           FIn.Read(BuffIn,TWidth*THeight);
           for x:=0 to 63 do
           for y:=0 to 63 do BuffOut[63-x,y]:=BuffIn[y,x];
           FOut.Write(BuffOut,TWidth*THeight);
         end;
  ftItem:begin
           FIn.Seek(SOffset,spBegin);
           FIn.Read(Word1,2);
           FIn.Read(Word2,2);
           //   
           DataOffset:=(Word2-Word1+3)*2;
           //  
           RealWidth:=(DataOffset-4)div 2;
           //  
           for i:=0 to RealWidth-1 do FIn.Read(CEntries[i],2);
           // 
           FillChar(BuffIn,64*64,$00);
           SetLength(SEntries,RealWidth);
           for i:=0 to RealWidth-1 do
           begin
             FIn.Seek(SOffset+CEntries[i],spBegin);
             FillChar(SmallBuff,64,$00);
             SetLength(SEntries[i],i+1);
//*****
             FIn.Read(TZero,2);
             if TZero<>0 then FIn.Seek(-2,spCurrent);
//*****
             SCount:=0;
             repeat
               FIn.Read(OffsetHigh,2);
               FIn.Read(Hlam,2);
               FIn.Read(OffsetLow,2);
               FIn.Read(TZero,2);
               if TZero<>0 then FIn.Seek(-2,spCurrent);
               Inc(SCount);
               SetLength(SEntries[i],SCount);
               SEntries[i][SCount-1].Low:=OffsetLow;
               SEntries[i][SCount-1].Offset:=Hlam;
               SEntries[i][SCount-1].High:=OffsetHigh;
             until (TZero=0);
           end;
           FIn.Seek(SOffset+DataOffset,spBegin);
           for i:=0 to RealWidth-1 do
           for j:=0 to High(SEntries[i]) do
           begin
             SegmentLength:=(SEntries[i][j].High-SEntries[i][j].Low) div 2;
             FIn.Read(SmallBuff,SegmentLength);
             SEntries[i][j].High:=SEntries[i][j].High div 2;
             SEntries[i][j].Low:=SEntries[i][j].Low div 2;
             for z:=0 to SegmentLength-1 do BuffIn[63-(z+SEntries[i][j].Low),i]:=SmallBuff[z];
           end;
           FOut.Write(BuffIn,64*64);
         end;
  end;
  FOut.Seek(0,spBegin);
end;

end.
